#include <ourhdr.h>
#include "myheader.h"

struct timeval startRT, startUserTime, startSysTime;


int StartRes (){
	struct rusage ru;
	if(gettimeofday(&startRT, NULL) < 0)
	      err_sys("Setting inizio");

	if (getrusage(RUSAGE_SELF, &ru)<0)
	        err_sys("Getting resource usage");
	else
	{
		startUserTime = ru.ru_utime;
		startSysTime = ru.ru_stime;
	}
	return EXIT_SUCCESS;
}

int StopRes ()
{
	struct rusage ru;
	struct timeval fine, res;

	if(gettimeofday(&fine, NULL) < 0)
	      err_sys("Setting fine");

	if (getrusage(RUSAGE_SELF, &ru)<0)
	        err_sys("Getting resource usage");
	else
	{
		timersub(&ru.ru_utime, &startUserTime, &res);
		printf ("User: %d.%03d\n",res.tv_sec, res.tv_usec / 1000);

		timersub(&ru.ru_stime, &startSysTime, &res);
		printf ("SYS: %d.%03d\n",	res.tv_sec, res.tv_usec / 1000);
	}

	timersub(&fine, &startRT, &res);
	printf("Real: %d.%03d\n", res.tv_sec, res.tv_usec / 1000);
	return EXIT_SUCCESS;
}
